-- this is what we refer to as "mustard gas"
-- as of 1.3, item odds in battle are fair ground for everyone (THAT MEANS A *3RD* REWRITE OF THIS HACK AAAAAAAAAAAAA)
local framework = battleplus.framework
local dprint = battleplus.dprint

-- base odds table, for fallback (1: normal odds, 2: karma odds)
local K_KartItemOddsBattle = {
				//P-Odds	 1  2
			   /*Sneaker*/ { 2, 1 }, // Sneaker
		/*Rocket Sneaker*/ { 0, 0 }, // Rocket Sneaker
		 /*Invincibility*/ { 2, 1 }, // Invincibility
				/*Banana*/ { 1, 0 }, // Banana
		/*Eggman Monitor*/ { 1, 0 }, // Eggman Monitor
			  /*Orbinaut*/ { 8, 0 }, // Orbinaut
				  /*Jawz*/ { 8, 1 }, // Jawz
				  /*Mine*/ { 4, 1 }, // Mine
			   /*Ballhog*/ { 2, 1 }, // Ballhog
   /*Self-Propelled Bomb*/ { 0, 0 }, // Self-Propelled Bomb
				  /*Grow*/ { 2, 1 }, // Grow
				/*Shrink*/ { 0, 0 }, // Shrink
		/*Thunder Shield*/ { 0, 0 }, // Thunder Shield
			   /*Hyudoro*/ { 2, 0 }, // Hyudoro
		   /*Pogo Spring*/ { 2, 0 }, // Pogo Spring
		  /*Kitchen Sink*/ { 0, 0 }, // Kitchen Sink
			/*Sneaker x3*/ { 0, 1 }, // Sneaker x3
			 /*Banana x3*/ { 1, 0 }, // Banana x3
			/*Banana x10*/ { 0, 1 }, // Banana x10
		   /*Orbinaut x3*/ { 2, 0 }, // Orbinaut x3
		   /*Orbinaut x4*/ { 1, 1 }, // Orbinaut x4
			   /*Jawz x2*/ { 2, 1 }  // Jawz x2
}
local TOTALITEMS = 22	-- much easier

-- check if an item can appear
framework.Main_GetItemOdds = function(pos, item, mashed, gamemode, p)
	dprint(3, "item: "..item)
	dprint(3, "pos: "..pos)
	
	-- check if the item is enabled
	local itemenabled = {
		CV_FindVar("sneaker").value,
		CV_FindVar("rocketsneaker").value,
		CV_FindVar("invincibility").value,
		CV_FindVar("banana").value,
		CV_FindVar("eggmanmonitor").value,
		CV_FindVar("orbinaut").value,
		CV_FindVar("jawz").value,
		CV_FindVar("mine").value,
		CV_FindVar("ballhog").value,
		CV_FindVar("selfpropelledbomb").value,
		CV_FindVar("grow").value,
		CV_FindVar("shrink").value,
		CV_FindVar("thundershield").value,
		CV_FindVar("hyudoro").value,
		CV_FindVar("pogospring").value,
		CV_FindVar("kitchensink").value,
		CV_FindVar("triplesneaker").value,
		CV_FindVar("triplebanana").value,
		CV_FindVar("decabanana").value,
		CV_FindVar("tripleorbinaut").value,
		CV_FindVar("quadorbinaut").value,
		CV_FindVar("dualjawz").value
	}
	if not (itemenabled[item])
		dprint(3, "item is not enabled")
		return 0
	end
	
	-- get odds table
	local oddstable = gamemode.itemodds or K_KartItemOddsBattle
	local newodds = (oddstable[item][pos])*4	-- *4 for fractional precision
	
	-- get values based on players
	local pingame, pexiting = 0, 0
	for p in players.iterate
		if not (p and p.valid) or p.spectator then continue end
		
		pingame = p.kartstuff[k_bumper] and $+1 or $
		pexiting = p.exiting and $+1 or $
		
		if (p.mo and p.mo.valid)
			if (p.kartstuff[k_itemtype] == KITEM_THUNDERSHIELD)
			and (item == KITEM_THUNDERSHIELD)
				dprint(3, "thunder shield already out")
				newodds = 0
			end
		end
	end
	
	-- god can we just get switch cases PLEASE
	local case_poweritems = {
	KRITEM_TRIPLEBANANA, KRITEM_TENFOLDBANANA,	-- bananas
	KITEM_ROCKETSNEAKER, KRITEM_TRIPLESNEAKER,	-- sneakers
	KRITEM_TRIPLEORBINAUT, KRITEM_QUADORBINAUT,	-- orbinauts
	KITEM_JAWZ, KRITEM_DUALJAWZ,	-- jawz
	KITEM_BALLHOG,	-- ballhog
	KITEM_INVINCIBILITY, KITEM_MINE, KITEM_GROW	-- cooldown items
	}
	local case_poweritemcooldowns = {KITEM_INVINCIBILITY, KITEM_MINE, KITEM_GROW}	-- have cooldowns separated too
	-- FUCK
	for i = 1, #case_poweritems
		if (item == case_poweritems[i])	-- we need to do stuff with it
			-- now check if it's a cooldown power item
			for j = 1, #case_poweritemcooldowns
				local starttime = 6*TICRATE + (3*TICRATE/4)
				
				if (item == case_poweritemcooldowns[j]) and (leveltime < (30*TICRATE)+starttime)
					dprint(3, "power item cooldown hasnt run out")
					newodds = 0
					break
				end
			end
			
			-- not on cooldown, do poweritem odds stuff
			if (franticitems) then newodds = $<<1 end	-- frantic odds, increase power item chance
			newodds = FixedMul($<<FRACBITS, FRACUNIT+(((8-pingame)<<FRACBITS)/25))>>FRACBITS
			-- they mashed like a cunt
			if (mashed > 0) then newodds = FixedDiv($<<FRACBITS, FRACUNIT + mashed)>>FRACBITS end
			
			break
		end
	end
	
	-- change odds with a gamemode function
	if (gamemode.itemoddsmodifier)
		dprint(3, "gamemode has an item odds modifier")
		newodds = gamemode.itemoddsmodifier(p, item, newodds)
	end
	
	dprint(3, "newodds: "..newodds)
	return newodds
end

-- get what tier we'll use for odds
framework.Main_FindUseOdds = function(p, mashed, gamemode)
	local oddsvalid = {}
	for pos = 1, 2
		local available = true
		
		-- check if an item is available for the tier
		for item = 1, TOTALITEMS
			if (framework.Main_GetItemOdds(pos, item, mashed, gamemode, p) > 0)
				available = true
				break
			end
		end
		
		oddsvalid[pos] = available
	end
	
	-- lets find the tier (as of v1.3, useodds are the same for everyone)
	local useodds
	if (p.kartstuff[k_itemblinkmode] == 2 and oddsvalid[2])	-- we use k_itemblinkmode since this is an override, k_itemroulettemode is already reset
		useodds = 2 -- use karma items
	else
		useodds = 1
		if not (oddsvalid[1]) and (oddsvalid[2])	-- fallback on karma items?
			useodds = 2
		end
	end
	
	dprint(3, "useodds: "..useodds)
	return useodds
end

framework.Main_GetItemOverride = function(p, item, override)
	-- reset cooldowns that wouldve activated
	if (item == KITEM_SPB or item == KITEM_SHRINK)
	and (indirectitemcooldown == (20*TICRATE-1))
		dprint(3, "reset indirectitemcooldown")
		K_SetIndirectItemCooldown(0)
	elseif (item == KITEM_HYUDORO and hyubgone == (20*TICRATE-1))
		dprint(3, "reset hyubgone")
		K_SetHyudoroCooldown(0)
	end
	
	-- now lets set our item to the override!
	local powerItems = {{KRITEM_TRIPLESNEAKER, KITEM_SNEAKER, 3}, {KRITEM_TRIPLEBANANA, KITEM_BANANA, 3}, {KRITEM_TENFOLDBANANA, KITEM_BANANA, 10}, {KRITEM_TRIPLEORBINAUT, KITEM_ORBINAUT, 3}, {KRITEM_QUADORBINAUT, KITEM_ORBINAUT, 4}, {KRITEM_DUALJAWZ, KITEM_JAWZ, 2}}
	for i = 1, #powerItems
		if (override == powerItems[i][1])
			p.kartstuff[k_itemtype] = powerItems[i][2]
			p.kartstuff[k_itemamount] = powerItems[i][3]
			break
		else
			-- set cooldowns if necessary
			if (override == KITEM_SPB or override == KITEM_SHRINK or override == KITEM_HYUDORO)
				local cooldownfunc = (override == KITEM_HYUDORO) and K_SetHyudoroCooldown or K_SetIndirectItemCooldown
				
				dprint(3, "set "..((override == KITEM_HYUDORO) and "hyubgone" or "indirectitemcooldown"))
				cooldownfunc(20*TICRATE)
			end
			
			p.kartstuff[k_itemtype] = override
			p.kartstuff[k_itemamount] = 1
		end
	end
end

framework.Main_ItemOdds = function(gamemode)
	if not (gamemode.itemodds or gamemode.itemoddsmodifier) then return end	-- no need for custom odds
	if CV_FindVar("kartdebugitem").value then return end	-- debug
	
	for p in players.iterate
		-- we need a substitute for "roulettestop"
		if (p.kartstuff[k_itemroulette])
			p.bp.itemroulette = p.kartstuff[k_itemroulette]
		end
		
		if (p.kartstuff[k_itemtype])
			if (p.bp.itemoverride) then continue end	-- already overridden
			if not (p.kartstuff[k_itemblink]) then continue end	-- only override during itemblink
			
			-- mashed?
			local mashed = 0
			if (p.kartstuff[k_itemblinkmode] == 1) -- they mashed
				local roulettestop = TICRATE+(3*(battleplus.GetPlayerCount()-p.kartstuff[k_position]))
				mashed = FixedDiv((p.bp.itemroulette)*FRACUNIT, ((TICRATE*3)+roulettestop)*FRACUNIT)-FRACUNIT
				dprint(3, "mashed: "..mashed)
			end
			
			-- get spawnchances
			local spawnchance, totalspawnchance = {}, 0
			-- init spawnchance values
			for item = 0, TOTALITEMS
				spawnchance[item] = 0
			end
			
			-- get useodds
			local useodds = framework.Main_FindUseOdds(p, mashed, gamemode)
			
			-- set spawnchance and totalspawnchance
			for item = 1, TOTALITEMS
				local odds = framework.Main_GetItemOdds(useodds, item, mashed, gamemode, p)
				totalspawnchance = $+odds
				spawnchance[item] = totalspawnchance
				dprint(3, "spawnchance["..item.."]: "..spawnchance[item])
			end
			
			if (totalspawnchance > 0)
				totalspawnchance = P_RandomKey(totalspawnchance)
				dprint(3, "totalspawnchance: "..totalspawnchance)
				
				local item = 0
				for i = 0, TOTALITEMS
					item = i
					if (spawnchance[i] > totalspawnchance)
						break
					end
				end
				dprint(3, "getitem: "..item)
				
				if (item <= 0 or item > TOTALITEMS)	-- fallback
					p.kartstuff[k_itemtype] = KITEM_SAD
					p.kartstuff[k_itemamount] = 1
				else	-- we got an item
					framework.Main_GetItemOverride(p, p.kartstuff[k_itemtype], item)
				end
			else	-- fuck
				p.kartstuff[k_itemtype] = KITEM_SAD
				p.kartstuff[k_itemamount] = 1
			end
			
			p.bp.itemoverride = true
		else
			p.bp.itemoverride = nil
		end
	end
end