local framework = battleplus.framework

framework.Unload_EnableHUDs = function()
	-- enabled ALL disabledhuds across gamemodes
	for k, gamemode in ipairs(battleplus.gamemodes)
		if not (gamemode.disabledhuds) then continue end
		
		for i = 1, #gamemode.disabledhuds
			hud.enable(gamemode.disabledhuds[i])
		end
	end
	-- enable time and gametypeinfo
	hud.enable("time")
	hud.enable("gametypeinfo")
end
framework.Unload_TeamSkincolors = function()
	for p in players.iterate
		if not (p.bp) then continue end
		if not (p.bp.savedskincolor) then continue end
		
		p.skincolor = p.bp.savedskincolor
		if (p.mo and p.mo.valid)
			p.mo.color = p.bp.savedskincolor
		end
		
		p.bp.savedskincolor = nil
	end
end

framework.Unload = function()
	-- run unload functions
	if (server.bp_server)
		local gamemode = battleplus.gamemodes[server.bp_server.gamemode]
		if (gamemode.unload) then gamemode.unload() end	-- run the gamemode function
	end
	
	-- now run functions
	framework.Unload_EnableHUDs()
	framework.Unload_TeamSkincolors()
	for p in players.iterate
		p.powers[pw_flashing] = 0	-- ok this "no damage" bug is really weird but hopefully this will end it
		p.bp = nil	-- reset battle plus vars
	end
	server.bp_server = nil	-- reset battle plus server vars
end