local bumperbattle = battleplus.bumperbattle

bumperbattle.Func = function()
	for p in players.iterate
		-- additional points that go to score
		p.bp.hud_hiddenpoints = 1*p.kartstuff[k_bumper]
	end
end

bumperbattle.FinishHook = function()
	for p in players.iterate
		-- give extra points on finish, based on bumpers
		if p.kartstuff[k_bumper] and not p.spectator
			p.marescore = $+(1*p.kartstuff[k_bumper])
			print(p.name.." received "..(1*p.kartstuff[k_bumper]).." additional point"..(p.kartstuff[k_bumper] == 1 and "!" or "s!"))
		end
	end
end

local bumperbattle_info = {
	name = "Bumper Battle",
	teamname = "Team Bumper Battle",
	objective = "Last one standing wins!",
	teamobjective = "Last team standing wins!",
	icon = "K_BMPBTL",
	teamicons = {"K_TMBTL1", "K_TMBTL2"},
	func = bumperbattle.Func,
	finishhook = bumperbattle.FinishHook,
	rules = BP_GMR_TEAMS|BP_GMR_TIMELIMIT|BP_GMR_BUMPERS,
	timelimit = bumperbattle.cv_timelimit,
	bumpers = bumperbattle.cv_bumpers,
}
battleplus.AddGamemode(BP_GM_BUMPERBATTLE, bumperbattle_info)