battleplus.eggfection = {}
local eggfection = battleplus.eggfection

-- DRIP
freeslot("S_BP_EF_METALDROP", "S_BP_EF_METALDROP_DEAD1", "S_BP_EF_METALDROP_DEAD2", "MT_BP_EF_METALDROP", "SPR_BPDP")
states[S_BP_EF_METALDROP] = {SPR_BPDP, A, -1, nil, 0, 0, S_BP_EF_METALDROP}
states[S_BP_EF_METALDROP_DEAD1] = {SPR_BPDP, B, 1, nil, 0, 0, S_BP_EF_METALDROP_DEAD2}
states[S_BP_EF_METALDROP_DEAD2] = {SPR_BPDP, C, 1, nil, 0, 0, S_NULL}
mobjinfo[MT_BP_EF_METALDROP] = {
	spawnstate = S_BP_EF_METALDROP,
	deathstate = S_BP_EF_METALDROP_DEAD1,
	radius = 2*FRACUNIT,
	height = 8*FRACUNIT,
	flags = MF_SCENERY,
}
addHook("MobjThinker", function(drop)
	if not ((drop and drop.valid) and drop.health) then return end
	
	-- die on impact with the ground
	if (P_IsObjectOnGround(drop))
		P_KillMobj(drop)
	end
end, MT_BP_EF_METALDROP)

eggfection.GetInfectedPlayers = function()
	local count = 0
	for p in players.iterate
		if (p.spectator) then continue end
		if not (p.bp.ef_infected) then continue end
		
		count = $+1
	end
	
	return count
end

eggfection.InfectPlayer = function(p, source, noscore)
	-- infect the player and give other survivors score!
	p.bp.ef_infected = true
	if not (noscore)
		for p2 in players.iterate
			if (p2.spectator) then continue end
			if (p2.bp.ef_infected) then continue end
			
			local points = 1
			p2.bp.ef_score = $ and $ + points or points
			battleplus.SpawnBattlePoints(p2, p, points)
		end
	end
	
	-- got a source? give them points!
	local source_string = ""
	if (source and source.valid)
		source_string = " by "..source.name	-- update this too!
		
		local points = 3
		source.bp.ef_score = $ and $ + points or points
		battleplus.SpawnBattlePoints(source, p, points)
		
		-- hitfeed support
		if (hitfeed)
			if not (HF_animIcon["K_HMEFT"]) then HF_animIcon["K_HMEFT"] = {2, 2} end
			
			local s = {{source.name, source.mo.hf_overridenamecolor or source.skincolor}, {skins[source.mo.skin].facemmap, source.skincolor}, source}
			local v = {{p.name, p.mo.hf_overridenamecolor or p.skincolor}, {skins[p.mo.skin].facemmap, p.skincolor}, p}
			HF_SendHitMessage(s, v, "K_HMEFT")
		end
	else
		-- hitfeed support
		if (hitfeed)
			if not (HF_animIcon["K_HMEFT"]) then HF_animIcon["K_HMEFT"] = {2, 2} end
			
			local v = {{p.name, p.mo.hf_overridenamecolor or p.skincolor}, {skins[p.mo.skin].facemmap, p.skincolor}, p}
			HF_SendHitMessage(nil, v, "K_HMEFT")
		end
	end
	
	-- announce to the serv
	print(p.name.." was infected"..source_string.."!")	-- append source's name if possible
	S_StartSound(nil, sfx_cdfm44)
end