local hoteggtato = battleplus.hoteggtato
local dprint = battleplus.dprint

-- death to magic numbers
local HE_CAMPINCREASE = 1500	-- when you hit someone tagged OR pass it on (*2)

-- player cheesing
hoteggtato.Func_PlayerCheese = function(p)
	if ((p.kartstuff[k_respawn] == 47) and not p.bp.he_tagged and not p.bp.he_eliminated) -- get punished for cheese
		if ((battleplus.GetPlayerCount() - battleplus.GetDeadCount()) == 2) -- last 2 left, you're getting tagged!
			-- first lets untag the currently tagged player
			for v in players.iterate
				if (v.bp.he_tagged)
					v.bp.he_tagged = nil
					battleplus.SmartSetColor(v, false, v.skincolor)
					break
				end
			end
			
			-- now tag the wuss
			hoteggtato.TagPlayer(p)
		end
		p.bp.he_respawned = $ and $+1 or 1
	end
end

hoteggtato.Func_PlayerCamping = function(p)
	local starttime = 6*TICRATE + (3*TICRATE/4)
	if not (leveltime > (starttime + TICRATE/2 + 1)) then return end	-- make sure it doesnt increase before the first person is tagged
	
	local mo = p.mo
	if not (mo and mo.valid) then return end
	if p.kartstuff[k_respawn] then return end
	
	local increase = (p.bp.he_tagged) and 35 or FixedHypot(mo.momx, mo.momy)>>FRACBITS	-- get a static increase if you're tagged
	p.bp.he_camptimer = $ and $+increase or increase
	if (p == displayplayers[0]) then dprint(4, p.name.."'s camptimer increase: "..increase) end
end

-- handle elimination
hoteggtato.Func_PlayerElimination = function(p)
	if not (p.bp.he_eliminated) then return end
	
	p.kartstuff[k_bumper] = 0	-- make sure this stays at 0
	if (p.mo and p.mo.health) then p.bp.he_eliminated = $+1 end
		
	-- no coming back till the round is over, but you can give items!
	p.kartstuff[k_comebackmode] = 1 -- you can only give items
	p.kartstuff[k_comebackpoints] = 0
end

-- handle player bumpgrace
hoteggtato.Func_PlayerBumpGrace = function(p)
	local mo = p.mo
	-- bump grace period
	if (p.bp.he_bumpgrace) 
		p.bp.he_bumpgrace = $-1
		mo.flags2 = (p.bp.he_bumpgrace%2) and $|(MF2_DONTDRAW) or $ & ~(MF2_DONTDRAW)
		if not (p.bp.he_bumpgrace)
			mo.flags2 = $ & ~(MF2_DONTDRAW)
		end
	end
end

-- handle tagged players
hoteggtato.Func_PlayerTagged = function(p)
	local mo = p.mo
	if (p.bp.he_tagged)
		-- bruh warning
		if (p.spectator)
			p.bp.he_tagged, p.bp.he_eliminated = nil, 1
			return
		end
		
		-- karma items!
		if (p.kartstuff[k_itemroulette])
		and (p.kartstuff[k_roulettetype] != 2)	-- don't prevent eggman roulette
			p.kartstuff[k_roulettetype] = 1
		end
		
		-- message timer
		p.bp.he_messagetimer = $ and $-1
		
		-- SPEED BOOST!!!!
		local speedboost, accelboost = p.kartstuff[k_speedboost], p.kartstuff[k_accelboost]
		-- get an additional increase as if you had invincibility!
		speedboost, accelboost = max(speedboost, 3*FRACUNIT/8), max(accelboost, 3*FRACUNIT/3)
		-- now let's reset k_speedboost and k_accelboost to apply the percentage increase!
		if (speedboost > p.kartstuff[k_speedboost])
			p.kartstuff[k_speedboost] = speedboost
		else
			p.kartstuff[k_speedboost] = $ + (speedboost - p.kartstuff[k_speedboost])/(TICRATE/2)
		end
		p.kartstuff[k_accelboost] = accelboost
		-- fast lines while you're moving
		if (p.speed > 0)
			local fast = P_SpawnMobj(mo.x+P_RandomRange(-36,36)*mo.scale, mo.y+P_RandomRange(-36,36)*mo.scale, mo.z+(mo.height/2)+(P_RandomRange(-20,20)*mo.scale), MT_FASTLINE)
			fast.angle = R_PointToAngle2(0, 0, mo.momx, mo.momy)
			fast.momx, fast.momy, fast.momz = 3*mo.momx/4, 3*mo.momy/4, 3*mo.momz/4
			fast.color, fast.colorized = SKINCOLOR_RED, true
			K_MatchGenericExtraFlags(fast, mo)
		end
		
		-- steam particles
		local rad = (mo.radius*2)>>FRACBITS	-- player radius
		local newx = mo.x + (P_RandomRange(-rad, rad)<<FRACBITS)
		local newy = mo.y + (P_RandomRange(-rad, rad)<<FRACBITS)
		local newz = mo.z + (P_RandomRange(0, mo.height>>FRACBITS)<<FRACBITS)
		
		local steam = P_SpawnMobj(newx, newy, newz, MT_SMOKE)
		steam.momz = P_RandomRange(1, 3)*steam.scale
		
		-- special effects when low countdowns
		local countdown = server.bp_server.he_countdown
		if ((countdown/TICRATE) < 10)
			-- play sound
			if not S_SoundPlaying(mo, sfx_kc51) then S_StartSound(mo, sfx_kc51) end
				
			-- FIREEEEEEEEE
			if not (leveltime%((countdown/TICRATE/2)+1))
				local fire = P_SpawnMobj(newx, newy, newz, MT_THOK)
				fire.sprite = SPR_FPRT
				fire.frame = ($ & ~(FF_TRANSMASK))|FF_FULLBRIGHT|TR_TRANS20
				fire.scale, fire.destscale = mo.scale*2, 1
				fire.scalespeed = mo.scale/12
				fire.momz = P_RandomRange(1, 3)*fire.scale
				fire.tics = TICRATE
			end
				
			-- flash colours
			local flashtime = 4<<(countdown/TICRATE)		
			if (countdown == 1 or (countdown%(flashtime/2) != 0))
				mo.colorized = false
				mo.color = p.skincolor
			elseif (countdown%flashtime == 0)
				mo.colorized = true
				mo.color = SKINCOLOR_BLACK
			else
				mo.colorized = true
				mo.color = SKINCOLOR_CRIMSON
			end
		end
	else
		p.bp.he_messagetimer = nil
	end
end

-- gamestate handler
hoteggtato.Func_Gamestate = function()
	local starttime = 6*TICRATE + (3*TICRATE/4)
	if not (leveltime > (starttime + TICRATE/2)) then return end
	
	if not (hoteggtato.GetTaggedPlayers())	-- we don't have any tagged players
		if ((battleplus.GetPlayerCount() - battleplus.GetDeadCount()) == 1)	-- only 1 player left, they won!
			-- check if round is already over
			for p in players.iterate
				if (p.exiting) then return end
			end
			
			-- tally up score and add to our victor
			for p in players.iterate
				if (p.kartstuff[k_bumper] and not p.spectator)	-- here's our victor
					local tally = 0
					for s in players.iterate
						if (s ~= p) then tally = $ + s.bp.he_score end
					end
					p.bp.he_score = (p.bp.he_score and p.bp.he_score+tally) or tally
					print(p.name.." received "..tally.." points for winning!")
					if (p.mo and p.mo.valid)
						S_StartSound(p.mo, sfx_kwin)
					end
				end
			end
			battleplus.EndBattle()
			return
		else
			local gracestart = (leveltime == starttime+(TICRATE/2)+1) and 1 or TICRATE*3/2
			server.bp_server.he_grace = $ or (gracestart)
			-- grace over?
			if (server.bp_server.he_grace)
				server.bp_server.he_grace = $-1
				
				if not (server.bp_server.he_grace)	-- grace period over, tag players
					-- get targets
					local possibleTargets = {{}, {}}	-- 1: normal players, 2: cheese
					local targets, wusses = possibleTargets[1], possibleTargets[2]	-- pointers
					for p in players.iterate
						if (p and p.valid) and not p.spectator
						and not (p.bp.he_eliminated)
							-- check if they cheesed or not
							if (p.bp.he_respawned)
								-- we'll want to store how many times they respawned
								-- we're gonna reset it later so we need to cache it
								table.insert(wusses, {p, p.bp.he_respawned})
							else
								local camptimer = p.bp.he_camptimer or 0	-- just incase it's the first round, we shouldnt have it then!
								
								table.insert(targets, {p, camptimer})
								dprint(4, p.name.."'s camptimer: "..camptimer)
								p.bp.he_camptimer = 0	-- might as well reset it here
							end
						end
						-- reset vars
						p.bp.he_tagged = nil
						p.bp.he_respawned = nil
						p.bp.he_sentmessage = nil
					end
					-- sort based on how many times they cheesed
					table.sort(wusses, function(a, b) return a[2] > b[2] end)
					
					local totaltargets = (#targets + #wusses)
					if (totaltargets)	-- we have targets to tag
						-- with more targets, tag more players!
						local tagamount = {1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 4}	-- there's probably a more optimal way to do this but I cant be fucked tbh
						
						-- tag players
						for i = 1, tagamount[totaltargets]
							if (i <= #wusses)	-- we still have cheesing players to tag
								local tp = wusses[i][1]
								hoteggtato.TagPlayer(tp)
							else	-- we can go to normal players
								-- go through players that was moving the least
								local best, index
								for j = 1, #targets
									local camptimer = targets[j][2]
									
									if (best == nil)
									or (camptimer < best or (camptimer == best and not P_RandomRange(0, 1)))
										best = camptimer
										index = j
									end
								end
								local tp = targets[index][1]
								
								-- tag them!
								hoteggtato.TagPlayer(tp)
								tp.bp.he_wastagged = nil	-- you didnt cheese, so get some grace with points
								
								-- remove from targets so they arent selected again
								table.remove(targets, index)
							end
						end
						
						-- set death countdown
						server.bp_server.he_countdown = max(10, hoteggtato.cv_countdown.value - battleplus.GetDeadCount())*TICRATE
					end
				end
			end
		end
	else	-- we have tagged players, run the countdown for their DEATH
		server.bp_server.he_countdown = $-1
		local countdown = server.bp_server.he_countdown
		
		if not (countdown%TICRATE)
			if not (countdown/TICRATE)
				-- award points
				for p in players.iterate
					-- eliminate players that were tagged
					if (p.bp.he_tagged)
						if (p.mo and p.mo.valid)	-- paranoia
							local mo = p.mo
							
							-- spawn separate origin for sounds so they dont cut out
							local soundmo = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_THOK)
							soundmo.state = S_INVISIBLE
							soundmo.tics = -1
							S_StartSound(soundmo, skins[mo.skin].soundsid[SKSKLOSE])
									
							-- blow them up
							S_StartSound(soundmo, sfx_s3k4e)
							K_SpawnMineExplosion(mo, mo.color)
							P_DamageMobj(mo, nil, nil, 10000)
						end
						-- set elim vars
						p.kartstuff[k_bumper] = 0
						p.bp.he_tagged, p.bp.he_eliminated = nil, 1
						print(p.name.." was eliminated!")
					else
						-- now give survivors points!
						if not (p.bp.he_eliminated)
							local points = p.bp.he_respawned and 1 or (p.bp.he_wastagged and 2 or 3)
							p.bp.he_score = $ and $+points or points
							battleplus.SpawnBattlePoints(p, p, points)
						end
					end
				end
			else
				S_StartSound(nil, (countdown/TICRATE) <= 10 and sfx_bptly or sfx_ptally)
			end
		end
	end
end

-- build the function
hoteggtato.Func = function()
	for p in players.iterate
		p.bp.he_score = $ or 0
		hoteggtato.Func_PlayerCheese(p)
		hoteggtato.Func_PlayerCamping(p)
		hoteggtato.Func_PlayerElimination(p)
		hoteggtato.Func_PlayerBumpGrace(p)
		hoteggtato.Func_PlayerTagged(p)
		p.marescore = p.bp.he_score
	end
	hoteggtato.Func_SeetheItems()
	hoteggtato.Func_Gamestate()
end

-- player damage
hoteggtato.PlayerDamage = function(p, inflictor, source)
	if not (p and p.mo) then return end	-- you need to exist
	if not (source and source.player) then return end	-- source needs to exist
	if (p == source.player) then return end	-- cant tag yourself, moron
	if (p.bp.he_tagged == source.player.bp.he_tagged) then return end	-- tagged status cant be the same
	
	if (p.bp.he_tagged)	-- hit player was tagged, increase the source's camp timer
		source.player.bp.he_camptimer = $ and $+HE_CAMPINCREASE or HE_CAMPINCREASE
	else	-- you're getting tagged
		-- untag source
		source.player.bp.he_tagged = nil
		battleplus.SmartSetColor(source.player, false, source.player.skincolor)
		source.player.bp.he_camptimer = $ and $+(HE_CAMPINCREASE*2) or HE_CAMPINCREASE*2
		-- tag victim
		hoteggtato.TagPlayer(p, source.player)
	end
end

-- player bumping
hoteggtato.PlayerBump = function(mo, mo2)
	if not battleplus.IsGamemode(BP_GM_HOTEGGTATO) then return end	-- not hot egg-tato
	
	if not ((mo2 and mo2.valid) and mo2.player) then return end
	local p, p2 = mo.player, mo2.player -- lazy
	
	-- a SHITTON of checks now
	if (p.bp.he_eliminated or p2.bp.he_eliminated) then return end
	if (p.kartstuff[k_justbumped] or p2.kartstuff[k_justbumped]) then return end
	if (p2.bp.he_tagged or not p.bp.he_tagged) then return end
	if (p.kartstuff[k_squishedtimer] or p.kartstuff[k_spinouttimer]) then return end
	if (p2.bp.he_bumpgrace) then return end
	
	if (abs(mo.z - mo2.z) <= P_GetPlayerHeight(p))	-- ladies and gentlemen, we got em
		-- untag source
		p.bp.he_tagged, p.bp.he_bumpgrace = nil, 3*TICRATE/2
		battleplus.SmartSetColor(p, false, p.skincolor)
		p.bp.he_camptimer = $ and $+(HE_CAMPINCREASE*2) or HE_CAMPINCREASE*2
		-- tag victim
		hoteggtato.TagPlayer(p2, p)
	end
end
addHook("MobjCollide", hoteggtato.PlayerBump, MT_PLAYER)
addHook("MobjMoveCollide", hoteggtato.PlayerBump, MT_PLAYER)

hoteggtato.HUDFunc_TaggedPlayers = function(v, p)
	if (battleplus.IsDisplayPlayer(p) ~= 0) then return end	-- reduce rendering as much as possible
	if (p.exiting) then return end
	if not (hoteggtato.GetTaggedPlayers()) then return end	-- no tagged players to even draw
	if (p.kartstuff[k_comebacktimer] and not p.kartstuff[k_bumper]) then return end
	
	local countdown = server.bp_server.he_countdown
	
	-- drawing vars
	local hx, hy, flags = 265, 129, V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_HUDTRANS
	if (splitscreen) > 1
		hx, hy, flags = 259, 145, V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_HUDTRANS
		if (splitscreen == 3)
			hx, flags = 131, V_SNAPTOBOTTOM|V_HUDTRANS
		end
	end
	
	-- retrieve the 1st and 2nd integers as separate variables
	local s = tostring((countdown/TICRATE)+1)
	local nums = {}
	if (tonumber(s) > 9)	-- more than 10, use 2 numbers
		nums = {tonumber(s:sub(1, 1)), tonumber(s:sub(2, 2))}
	else	-- only 1 number
		nums = {0, tonumber(s)}
	end
	
	-- get players that are tagged
	local taggedplayers = {}
	for i in players.iterate
		if not (i.bp.he_tagged) then continue end
		table.insert(taggedplayers, i)
	end
	
	-- poster
	v.draw(hx, hy, v.cachePatch((splitscreen) > 1 and "K_4TEGGT" or "K_HTEGGT"), flags, v.getColormap(-1, taggedplayers[1].skincolor))
	-- tagged players
	for i = 1, #taggedplayers
		local tp = taggedplayers[i]
						
		-- setup flashing for the HUD
		local colour = tp.skincolor
		if ((countdown/TICRATE) < 10)
			local flashtime = 4<<(countdown/TICRATE)
							
			if (countdown == 1 or (countdown%(flashtime/2) != 0))
				colour = tp.skincolor
			elseif (countdown%flashtime == 0)
				colour = SKINCOLOR_BLACK -- black
			else
				colour = SKINCOLOR_CRIMSON -- crimson
			end
		end
						
		if (tp.mo and tp.mo.valid)
			-- wanted reticule
			v.drawOnMinimap(tp.mo.x, tp.mo.y, FRACUNIT, v.cachePatch("MMAPWANT"))
			-- player icons
			if (hoteggtato.GetTaggedPlayers() == 1)
				v.draw(hx+((splitscreen) > 1 and 13 or 8), hy+((splitscreen) > 1 and 16 or 21), v.cachePatch(skins[tp.mo.skin].facewant), flags, v.getColormap(TC_RAINBOW, colour))
			else
				local index_shift = {{0, 0}, {16, 0}, {0, 16}, {16, 16}}
				v.draw(hx+((splitscreen) > 1 and 13 or 8)+index_shift[i][1], hy+((splitscreen) > 1 and 16 or 21)+index_shift[i][2], v.cachePatch(skins[tp.mo.skin].facerank), flags, v.getColormap(TC_RAINBOW, colour))
			end
		end
	end
	-- numbers
	if not ((((countdown/TICRATE)+1) <= 10) and leveltime%10 >= 5)
		v.draw(hx+((splitscreen) > 1 and 32 or 28), hy+((splitscreen) > 1 and 3 or 5), v.cachePatch(((splitscreen) > 1 and "WTSONT" or "WTFONT")..nums[1]), flags, v.getColormap(-1, taggedplayers[1].skincolor))
		v.draw(hx+((splitscreen) > 1 and 38 or 34), hy+((splitscreen) > 1 and 3 or 5), v.cachePatch(((splitscreen) > 1 and "WTSONT" or "WTFONT")..nums[2]), flags, v.getColormap(-1, taggedplayers[1].skincolor))
	end
end

hoteggtato.HUDFunc_TaggedRadar = function(v, p, c)
	if (p.exiting) then return end

	local mo = p.mo

	-- we want to disable check, unless we're tagged!
	if (p.bp.he_tagged)
		hud.enable("check")
		return	-- we don't want to render anything else
	end

	-- we have no mo to work with
	if not (mo and mo.valid) then return end
	
	for i in players.iterate
		if not (i.bp.he_tagged) then continue end	-- not tagged, no need to highlight
		if not (i.mo and i.mo.valid) then continue end	-- no mo? fuck no
		
		local trackx, tracky, trackz = i.mo.x, i.mo.y, i.mo.z
		if (trackx == nil or tracky == nil or trackz == nil) then return end	-- failsafe

		-- get position of the emerald
		local x, y, behind, scale = battleplus.MapToScreen(p, c, trackx, tracky, trackz)
		-- offset y position
		local playerheight = FixedMul(scale, i.mo.height)*P_MobjFlip(i.mo)
		local offset = FixedMul(scale, 10*FRACUNIT)*P_MobjFlip(i.mo)
		y = $ - playerheight - offset

		x = $/FRACUNIT
		y = $/FRACUNIT

		-- define patch vars
		local patch_prefix = "FR"
		local flags = 0
		-- set patch vars based on conditions
		if (behind)
			x = min(306, max(14, $))
			y = 200
			patch_prefix = "BH"
			flags = V_SNAPTOBOTTOM
		elseif (x < 28 or x > 292)
			local right = (x > 292)

			x = (right) and 320 or 0
			y = 100
			patch_prefix = "SI"
			flags = (right) and V_SNAPTORIGHT|V_FLIP or V_SNAPTOLEFT
			x = $ + ((right) and 33 or 0)
		end

		x = min(320, max(0, $))
		y = min(200, max(0, $))

		-- make splitscreen work. :oh:
		local gscale = FRACUNIT
		if splitscreen
			flags = battleplus.ReturnSplitFlags(flags, p.splitscreenindex)

			if splitscreen
				y = $/2
			end
			if splitscreen > 1
				x = $/2
				gscale = FRACUNIT/2
			end
		end

		v.drawScaled(x<<FRACBITS, y<<FRACBITS, gscale, v.cachePatch("K_EGG"..patch_prefix..(leveltime & 1 and 2 or 1)), V_HUDTRANS|flags, v.getColormap(-1, i.skincolor))
	end
end

hoteggtato.HUDFunc_Message = function(v, p)
	if (p.exiting or not p.bp.he_messagetimer) then return end
	local dp = battleplus.IsDisplayPlayer(p)
	
	if (splitscreen > 1)
		local flags = {battleplus.ReturnSplitFlags(V_SNAPTOTOP|V_SNAPTOLEFT|V_SNAPTORIGHT|V_HUDTRANS, dp), battleplus.ReturnSplitFlags(V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_SNAPTORIGHT|V_HUDTRANS, dp)}
				
		v.drawString(80-(v.stringWidth("YOU'VE BEEN TAGGED!!", 0, "thin")/2), 10, "YOU'VE BEEN TAGGED!!!", flags[1], "thin")
		v.drawString(80-(v.stringWidth("Tag someone with an item or", 0, "thin")/2), 76, "Tag someone with an item or", flags[2], "thin")
		v.drawString(80-(v.stringWidth("contact before you're eliminated!", 0, "thin")/2), 85, "contact before you're eliminated!", flags[2], "thin")
	else
		local hy = (splitscreen) and {10, 76, 85} or {52, 150, 159}
		local flags = {battleplus.ReturnSplitFlags(V_SNAPTOTOP|V_HUDTRANS, dp), battleplus.ReturnSplitFlags(V_SNAPTOBOTTOM|V_HUDTRANS, dp)}
				
		v.drawString(160, hy[1], ("YOU'VE BEEN TAGGED!!!"), flags[1], "center")
		v.drawString(160, hy[2], ("Tag someone with an item or"), flags[2], "center")
		v.drawString(160, hy[3], ("contact before you're eliminated!"), flags[2], "center")
	end
end
hoteggtato.HUDFunc = function(v, p, c)
	hoteggtato.HUDFunc_TaggedPlayers(v, p)
	hoteggtato.HUDFunc_TaggedRadar(v, p, c)
	hoteggtato.HUDFunc_Message(v, p)
end

local hoteggtato_info = {
	name = "Hot Egg-tato",
	objective = "Don't get tagged!",
	icon = "K_ITEGGM",
	func = hoteggtato.Func,
	playerspin = hoteggtato.PlayerDamage,
	playersquish = hoteggtato.PlayerDamage,
	playerexplode = hoteggtato.PlayerDamage,
	hudfunc = hoteggtato.HUDFunc,
	rules = BP_GMR_HELL|BP_GMR_ELIMINATION|BP_GMR_REMOVEWANTED|BP_GMR_REMOVEPOINTS,
	itemodds = hoteggtato.ItemOdds,
}
battleplus.AddGamemode(BP_GM_HOTEGGTATO, hoteggtato_info)