-- seperate from main script for clarity
local hoteggtato = battleplus.hoteggtato

-- seethe items from tagged players for identification
local seetheItems = {
	MT_EGGMANITEM, MT_EGGMANITEM_SHIELD,
	MT_BANANA, MT_BANANA_SHIELD,
	MT_ORBINAUT, MT_ORBINAUT_SHIELD,
	MT_JAWZ, MT_JAWZ_DUD, MT_JAWZ_SHIELD,
	MT_SSMINE_SHIELD, MT_SSMINE,
	MT_BALLHOG
}
for i = 1, #seetheItems
	addHook("MobjSpawn", function(item) 
		if not (item and item.valid) then return end
		if not G_BattleGametype() then return end
		if not battleplus.IsGamemode(BP_GM_HOTEGGTATO) then return end	-- not emerald thief

		-- add mo to the table of stuff to do
		if not (server.bp_server.he_seetheitems) then return end	-- safety
		server.bp_server.he_seetheitems[#server.bp_server.he_seetheitems+1] = item
	end, seetheItems[i])
end
hoteggtato.Func_SeetheItems = function()
	if not (server.bp_server.he_seetheitems)
		server.bp_server.he_seetheitems = {}
		if not (#server.bp_server.he_seetheitems) then return end
	end
	
	local i = #server.bp_server.he_seetheitems
	while i
		local mo = server.bp_server.he_seetheitems[i]
		-- everything else is copypaste from TSR
		
		-- check if mo is still valid
		if not (mo and mo.valid) or not mo.health
			table.remove(server.bp_server.he_seetheitems, i)
			i = $-1
			continue
		end
		
		mo.he_savedcolor = $ or mo.color	-- save color
		-- now make the item seethe
		if mo.target
			if (mo.target.player and mo.target.player.bp.he_tagged)
				-- seethe the item to make players know it's dangerous
				local steam = P_SpawnMobj(mo.x+P_RandomRange(-25, 25)*mo.scale, mo.y+P_RandomRange(-25, 25)*mo.scale, mo.z+P_RandomRange(5, 30)*mo.scale, MT_SMOKE)
				P_SetObjectMomZ(steam, P_RandomRange(1, 3)*mo.scale)
								
				mo.colorized = (leveltime%5 == 4) and true or false
				mo.color = (leveltime%5 == 4) and SKINCOLOR_CRIMSON or mo.he_savedcolor
			else
				mo.colorized = false
				mo.color = mo.he_savedcolor
			end
		else
			mo.colorized = false
			mo.color = mo.he_savedcolor
		end
		
		i = $-1
	end
end

hoteggtato.ItemOdds = {
				//P-Odds	 1  2
			   /*Sneaker*/ { 2, 0 }, // Sneaker
		/*Rocket Sneaker*/ { 0, 0 }, // Rocket Sneaker
		 /*Invincibility*/ { 0, 0 }, // Invincibility
				/*Banana*/ { 1, 0 }, // Banana
		/*Eggman Monitor*/ { 1, 0 }, // Eggman Monitor
			  /*Orbinaut*/ { 8, 0 }, // Orbinaut
				  /*Jawz*/ { 8, 1 }, // Jawz
				  /*Mine*/ { 4, 1 }, // Mine
			   /*Ballhog*/ { 2, 1 }, // Ballhog
   /*Self-Propelled Bomb*/ { 0, 0 }, // Self-Propelled Bomb
				  /*Grow*/ { 0, 0 }, // Grow
				/*Shrink*/ { 0, 0 }, // Shrink
		/*Thunder Shield*/ { 0, 0 }, // Thunder Shield
			   /*Hyudoro*/ { 2, 0 }, // Hyudoro
		   /*Pogo Spring*/ { 0, 0 }, // Pogo Spring
		  /*Kitchen Sink*/ { 0, 0 }, // Kitchen Sink
			/*Sneaker x3*/ { 0, 1 }, // Sneaker x3
			 /*Banana x3*/ { 1, 0 }, // Banana x3
			/*Banana x10*/ { 0, 1 }, // Banana x10
		   /*Orbinaut x3*/ { 2, 0 }, // Orbinaut x3
		   /*Orbinaut x4*/ { 1, 1 }, // Orbinaut x4
			   /*Jawz x2*/ { 2, 1 }  // Jawz x2
}