local sinkdeathmatch = battleplus.sinkdeathmatch

-- give sinks
sinkdeathmatch.Func_PlayerSinks = function(p)
	if p.kartstuff[k_itemtype] -- player has an item
		-- give DOUBLE items from karma
		if (p.kartstuff[k_itemblinkmode] == 2) then p.sd_doubleitem = true end
			
		if (p.kartstuff[k_itemtype] ~= 16) -- item the player has isnt a sink, lets fix that
			p.kartstuff[k_itemtype] = KITEM_KITCHENSINK
			p.kartstuff[k_itemamount] = p.sd_doubleitem and 2 or 1
		end
	else
		p.sd_doubleitem = nil
	end
end
-- elimination
sinkdeathmatch.Func_PlayerElimination = function(p)
	-- player got hit, what a nub!!!
	if not p.kartstuff[k_bumper] 
		-- no coming back in this gamemode, once you're out you're out for good!
		p.kartstuff[k_comebackmode] = 1 -- you can only give items
		p.kartstuff[k_comebackpoints] = 0
	end
end
-- overtime
sinkdeathmatch.Func_Overtime = function()
	if (server.bp_server.timelimit.overtime)
		-- check if round is over
		for p in players.iterate
			if (p.exiting) then return end
			
			-- karma items!
			if (p.kartstuff[k_itemroulette])
				p.kartstuff[k_roulettetype] = 1
			end
		end
		
		local overtime = server.bp_server.timelimit.overtime
		
		if not (leveltime%(35/max(1, ((overtime/(10*TICRATE))+1))))
			S_StartSound(nil, sfx_s3k51)
			for i = 1, 1*((overtime/(10*TICRATE))+1)
				local possiblePlayers = {}
				for p in players.iterate
					if (p and p.mo) and not p.spectator then table.insert(possiblePlayers, p.mo) end
				end
				
				if #possiblePlayers -- we have atleast 1 target
					-- our target player
					local tmo = possiblePlayers[P_RandomRange(1, #possiblePlayers)]
							
					-- the actual hazard
					local hazard = P_SpawnMobj(tmo.x+P_RandomRange(-1250, 1250)<<FRACBITS, tmo.y+P_RandomRange(-1250, 1250)<<FRACBITS, tmo.ceilingz-P_RandomRange(0, 150)<<FRACBITS, MT_SINK)
					hazard.momx, hazard.momy = P_RandomRange(-8, 8)*(mapobjectscale), P_RandomRange(-8, 8)*(mapobjectscale)
					hazard.momz = P_MobjFlip(hazard)*(P_RandomRange(0, 8)*(mapobjectscale))
								
					-- pop into existence with style
					local pop = P_SpawnMobj(hazard.x, hazard.y, hazard.z, MT_THOK)
					pop.state = S_XPLD1
				end
			end
		end
	end
end

-- build the function
sinkdeathmatch.Func = function()
	for p in players.iterate
		sinkdeathmatch.Func_PlayerSinks(p)
		sinkdeathmatch.Func_PlayerElimination(p)
	end
	sinkdeathmatch.Func_Overtime()
end

-- damage function
sinkdeathmatch.MobjDamage = function(mo, inflictor, source)
	if (inflictor and inflictor.type == MT_SINK)
		if (source and source.player)
			if (source.player == mo.player) -- they hit themselves LMAO
				for p in players.iterate
					COM_BufInsertText(p, "cecho "..mo.player.name.."\\was hit by their own\\kitchen sink.\\\\\\")
				end
			elseif (server.bp_server.teamgamemode)
			and (source.player.bp.team == mo.player.bp.team)
				for p in players.iterate
					COM_BufInsertText(p, "cecho "..mo.player.name.."\\was hit by \\their own teammate's\\kitchen sink.\\\\")
				end
			else
				if not (mo.player.kartstuff[k_bumper] <= 0 and (mo.player.kartstuff[k_comebackmode] or mo.player.kartstuff[k_comebacktimer]))
					K_SpawnBattlePoints(source.player, mo.player, (K_IsPlayerWanted(mo.player) and 3 or 2))
					source.player.marescore = $+(K_IsPlayerWanted(mo.player) and 3 or 2)
				end
			end
		end
		if not ((source and source.player) and source.player == mo.player) -- they didnt hit themselves so win sound wont be playing (avoiding using S_SoundPlaying for obvious reasons)
			S_StartSound(mo, sfx_khurt1+P_RandomRange(0, 1))
		end
		K_SpawnMineExplosion(mo, mo.color)
		S_StartSound(mo, sfx_s3k4e)
	end
end

local sinkdeathmatch_info = {
	name = "Sink Deathmatch",
	teamname = "Team Sink Deathmatch",
	objective = "Last one standing wins!",
	teamobjective = "Last team standing wins!",
	icon = "K_ITSINK",
	func = sinkdeathmatch.Func,
	mobjdamage = sinkdeathmatch.MobjDamage,
	rules = BP_GMR_TEAMS|BP_GMR_HELL|BP_GMR_TIMELIMIT|BP_GMR_OVERTIME|BP_GMR_BUMPERS|BP_GMR_ELIMINATION,
	timelimit = sinkdeathmatch.cv_timelimit,
	bumpers = sinkdeathmatch.cv_bumpers,
}
battleplus.AddGamemode(BP_GM_SINKDEATHMATCH, sinkdeathmatch_info)