-- load tsrb2kr.cfg when the pk3 is added to load settings!
freeslot("sfx_bpcrea", "sfx_bpload")
local loaded = false

-- store commands, we'll iterate through this to create a config if necessary
local commands = {
	{battleplus.cv_t1c, "Changes Team 1's colour"}, 
	{battleplus.cv_t2c, "Changes Team 2's colour"}, 
}

addHook("ThinkFrame", do
	if (loaded) then return end
	
	-- create/load the config!
	local config = io.open("battleplus.cfg", "r")
	if not (config)	-- no config? create one.
		config = io.open("battleplus.cfg", "w")	-- create it.
			
		-- write all our defaults to it.
		for i = 1, #commands
			local command = commands[i][1]
			local command_desc = commands[i][2]
				
			config:write(command.name.." "..command.defaultvalue.." // "..command_desc.."\n")
		end
			
		CONS_Printf(consoleplayer, "\x83NOTICE:\x80 battleplus.cfg not found, created a config in \x82/luafiles\x80.")
		S_StartSound(nil, sfx_bpcrea, consoleplayer)
	else	-- we got a config, load it!
		for line in config:lines()
			COM_BufInsertText(consoleplayer, line)
		end
		CONS_Printf(consoleplayer, "\x83NOTICE:\x80 Successfully loaded battleplus.cfg!")
		S_StartSound(nil, sfx_bpload, consoleplayer)
	end
	config:close()
		
	-- set this to true, we dont wanna do this again.
	loaded = true
end)