-- general freeslots
-- sounds
freeslot("sfx_noooo3", "sfx_1mnlft", "sfx_bptly", "sfx_8blose", "sfx_bpcrsh")

-- team marker
freeslot("MT_BP_TEAMMARKER", "S_BP_TEAMMARKER", "SPR_BPTM")
states[S_BP_TEAMMARKER] = {SPR_BPTM, A|FF_ANIMATE, -1, nil, 1, 4, S_BP_TEAMMARKER}
mobjinfo[MT_BP_TEAMMARKER] = {
	spawnstate = S_BP_TEAMMARKER,
	deathstate = S_NULL,
	spawnhealth = 1000,
	radius = 36*FRACUNIT,
	height = 37*FRACUNIT,
	dispoffset = -2,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_DONTENCOREMAP
}
addHook("MobjThinker", function(marker)
	if (marker and marker.valid)
		-- now for remove situations
		if not (marker.target and marker.target.player) then P_RemoveMobj(marker) return end -- they dont have a target, or it's not a player
		if not (marker.target.player.health) then P_RemoveMobj(marker) return end -- target is dead
		if not (marker.target.player.bp.team) then P_RemoveMobj(marker) return end	-- they dont have a team?
		
		local c = {battleplus.cv_t1c.value, battleplus.cv_t2c.value}
		marker.color = c[marker.target.player.bp.team]

		-- don't draw if the target isnt drawn
		if (marker.target.flags2 & MF2_DONTDRAW)
			marker.flags2 = $|MF2_DONTDRAW
		else
			marker.flags2 = $ & ~MF2_DONTDRAW
		end
		
		local s = 3*marker.target.scale/2 -- base scale
		-- set scale
		if not (splitscreen)
			if (displayplayers[0] and displayplayers[0].valid)
				s = marker.target.scale + FixedMul(FixedDiv(abs(P_AproxDistance(displayplayers[0].mo.x - marker.target.x, displayplayers[0].mo.y - marker.target.y)), 1280<<FRACBITS), marker.target.scale)
				if (s > 16*marker.target.scale)
					s = 16*marker.target.scale
				end
			end
		end
		marker.destscale = s
		
		-- hide if this guy ain't our teammate (with splitscreen support, BLESS 1.2)
		local drawFlags = {MFE_DRAWONLYFORP1, MFE_DRAWONLYFORP2, MFE_DRAWONLYFORP3, MFE_DRAWONLYFORP4}
		for i = 0, (splitscreen) -- go through displayplayers
			if not displayplayers[i] then break end
			if (marker.target.player == displayplayers[i]) then marker.eflags = $ & ~(drawFlags[i+1]) continue end -- dont show yourself
					
			if (displayplayers[i].bp.team == marker.target.player.bp.team)
				marker.eflags = $|drawFlags[i+1]
			else
				marker.eflags = $ & ~(drawFlags[i+1])
			end
		end
		-- somehow this isnt supposed to be displayed at ALL for any displayplayers, so dont draw it
		if not (marker.eflags & (MFE_DRAWONLYFORP1|MFE_DRAWONLYFORP2|MFE_DRAWONLYFORP3|MFE_DRAWONLYFORP4))
			marker.flags2 = $|MF2_DONTDRAW
		end
		
		-- flash at the beginning of the game
		-- also hide if they're in their karma comeback timer
		if ((leveltime >= 106 and leveltime <= 146) and (leveltime-106)%10 >=5)
		or (marker.target.player.kartstuff[k_comebacktimer] and not marker.target.player.kartstuff[k_bumper])
			marker.flags2 = $|MF2_DONTDRAW
		end

		-- set position (flip support too)
		if (marker.target.eflags & MFE_VERTICALFLIP)
			P_TeleportMove(marker, marker.target.x, marker.target.y, marker.target.z - P_GetPlayerHeight(marker.target.player) - (16*marker.target.scale) - (64*s))
			marker.eflags = $|MFE_VERTICALFLIP
		else
			P_TeleportMove(marker, marker.target.x, marker.target.y, marker.target.z + P_GetPlayerHeight(marker.target.player) + (16*marker.target.scale) + (64*s))
			marker.eflags = $ & ~MFE_VERTICALFLIP
		end
	end
end, MT_BP_TEAMMARKER)

-- team items
freeslot("SPR_TBNA", "SPR_TJWZ", "SPR_THOG", "SPR_TSPB")

-- team item marker
freeslot("S_BP_ITEMMARKER", "MT_BP_ITEMMARKER", "SPR_BPTH")
states[S_BP_ITEMMARKER] = {SPR_BPTH, A|FF_ANIMATE, -1, nil, 1, 4, S_BP_ITEMMARKER}
mobjinfo[MT_BP_ITEMMARKER] = {
	spawnstate = S_BP_ITEMMARKER,
	deathstate = S_NULL,
	spawnhealth = 1000,
	radius = 36*FRACUNIT,
	height = 37*FRACUNIT,
	dispoffset = -2,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_DONTENCOREMAP
}
addHook("MobjThinker", function(marker)
	if (marker and marker.valid)
		-- now for remove situations
		if not (marker.target and marker.target.valid) then P_RemoveMobj(marker) return end -- they dont have a target
		if not (marker.target.health) then P_RemoveMobj(marker) return end -- target is dead
		if not (marker.target.target and marker.target.target.valid) then P_RemoveMobj(marker) return end	-- item has no target
		if not (marker.target.target.player.bp.team) then P_RemoveMobj(marker) return end	-- item target has no team
		
		local c = {battleplus.cv_t1c.value, battleplus.cv_t2c.value}
		marker.color = c[marker.target.target.player.bp.team]
		
		local s = 3*marker.target.scale/2 -- base scale
		marker.frame = $|FF_FULLBRIGHT

		-- set scale
		if not (splitscreen)
			if (displayplayers[0] and displayplayers[0].valid) and (displayplayers[0].mo and displayplayers[0].mo.valid)
				s = min(16*marker.target.scale, marker.target.scale + FixedMul(FixedDiv(abs(P_AproxDistance(displayplayers[0].mo.x - marker.target.x, displayplayers[0].mo.y - marker.target.y)), 1280<<FRACBITS), marker.target.scale))
			end
		end
		marker.destscale = s

		-- show on teammates and hide on self, with splitscreen support (you already know what I'm gonna bless, 1.2)
		local drawFlags = {MFE_DRAWONLYFORP1, MFE_DRAWONLYFORP2, MFE_DRAWONLYFORP3, MFE_DRAWONLYFORP4}
		for i = 0, (splitscreen) -- go through displayplayers
			if not displayplayers[i] then break end
			if (marker.target.target.player == displayplayers[i]) then marker.eflags = $ & ~(drawFlags[i+1]) continue end -- dont show yourself
					
			if (displayplayers[i].bp.team == marker.target.target.player.bp.team)
			and not CV_FindVar("friendlyfire").value	-- friendlyfire is on, dont mislead
				marker.eflags = $|drawFlags[i+1]
			else
				marker.eflags = $ & ~(drawFlags[i+1])
			end
		end
		-- somehow this isnt supposed to be displayed at ALL for any displayplayers, so dont draw it
		if not (marker.eflags & (MFE_DRAWONLYFORP1|MFE_DRAWONLYFORP2|MFE_DRAWONLYFORP3|MFE_DRAWONLYFORP4))
			marker.flags2 = $|MF2_DONTDRAW
		else
			marker.flags2 = $ & ~MF2_DONTDRAW
		end

		-- set position (flip support too)
		if (marker.target.eflags & MFE_VERTICALFLIP)
			P_TeleportMove(marker, marker.target.x, marker.target.y, marker.target.z - (2*marker.target.scale) - (16*s))
			marker.eflags = $|MFE_VERTICALFLIP
		else
			P_TeleportMove(marker, marker.target.x, marker.target.y, marker.target.z + marker.target.height + (2*marker.target.scale) + (16*s))
			marker.eflags = $ & ~MFE_VERTICALFLIP
		end
	end
end, MT_BP_ITEMMARKER)

-- battle plus points object (for numbers above 3!)
freeslot("MT_BP_BATTLEPOINT")
mobjinfo[MT_BP_BATTLEPOINT] = {
	spawnstate = S_INVISIBLE,
	radius = 8*FRACUNIT,
	height = 8*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_DONTENCOREMAP
}
addHook("MobjThinker", function(point)
	if not (point.target and point.target.valid)
		P_RemoveMobj(point)
		return
	end
	local mo = point.target	-- laziness
	
	-- match height
	local dest_height = mo.height + (FixedMul(mo.scale, point.bp_zoffset or 0))
	if (point.movefactor < dest_height)
		point.movefactor = min(dest_height, $ + (dest_height / 6))
	elseif (point.movefactor > dest_height)
		point.movefactor = max(dest_height, $ - (dest_height / 6))
	end
	
	-- follow target
	local newx, newy = mo.x, mo.y
	if (point.bp_xyoffset)
		local angle = mo.angle + ANGLE_90
		local xy_offset = point.bp_xyoffset
		
		newx = $ + FixedMul(mo.scale, xy_offset*cos(angle))
		newy = $ + FixedMul(mo.scale, xy_offset*sin(angle))
	end
	
	local newz = mo.z + (mo.height/2) + point.movefactor
	K_MatchGenericExtraFlags(point, mo)
	P_TeleportMove(point, newx, newy, newz)
end, MT_BP_BATTLEPOINT)