-- separate from main script for code clarity
local mineblast = battleplus.mineblast

/*
local spawncount = {0, 0, 0}
-- framerate saver for your own good:
addHook("MobjSpawn", function(mo)
    if not battleplus.IsGamemode(BP_GM_MINEBLAST) then return end	-- not mine blast
	-- increase spawncount
	spawncount[1] = $+1
	if not (spawncount[1]%32) then return end
	-- dont draw if conditions are right
	mo.flags = $|MF_NOSECTOR
end, MT_BOOMEXPLODE)
addHook("MobjSpawn", function(mo)
    if not battleplus.IsGamemode(BP_GM_MINEBLAST) then return end	-- not mine blast
	-- increase spawncount
	spawncount[2] = $+1
	if not (spawncount[2]%32) then return end
	-- dont draw if conditions are right
	mo.flags = $|MF_NOSECTOR
end, MT_BOOMPARTICLE)
addHook("MobjSpawn", function(mo)
    if not battleplus.IsGamemode(BP_GM_MINEBLAST) then return end	-- not mine blast
	-- increase spawncount
	spawncount[3] = $+1
	if not (spawncount[3]%4) then return end
	-- dont draw if conditions are right
	mo.flags = $|MF_NOSECTOR
end, MT_SMOKE)
*/
-- recreation of PIT_MineExplode
mineblast.BlowMines = function(mo, mo2)

	if not (mo and mo.valid) then return true end	-- it's already dead

	-- what DONT we want to blow up?
	if not ((mo2 and mo2.valid) and mo2.health) then return end	-- needs to be alive
	if (mo2 == mo) then return end	-- dont do things to yourself
	if (mo2.type == MT_MINEEXPLOSIONSOUND) then return end	-- dont harm the sound
	if (mo2.flags & MF_SCENERY) then return end	-- dont harm scenery
	if not (mo2.flags & MF_SHOOTABLE) then return end	-- we only want to affect shootables
	if (mo2.player and mo2.player.spectator) then return end	-- they're a player, but they're spectating, BAD
	-- ok I dont know what this last check is but I'm putting it in for consistency with source
	if G_BattleGametype() and (mo.target and mo.target.player)
	and (mo.target.player.kartstuff[k_bumper] <= 0)
	and (mo2 == mo.target)
		return
	end

	-- position checks
	local explodedist = FixedMul((3*mo.info.painchance)/2, mapobjectscale)

	if ((mo.z - explodedist) > (mo2.z + mo2.height)) then return end	-- above
	if ((mo.z + mo.height + explodedist) < mo2.z) then return end	-- under
	if (P_AproxDistance(P_AproxDistance(mo2.x - mo.x, mo2.y - mo.y), mo2.z - mo.z) > explodedist) then return end	-- too far

	if (mo2.player)
		K_ExplodePlayer(mo2.player, mo.target, mo)
		return
	else
		P_DamageMobj(mo2, mo, mo.target, 1)
		return
	end
	BP_ExplodeMine(mo2)
end

-- recreate explosions for mine blast
rawset(_G, "BP_ExplodeMine", function(actor, var1, var2)
	if not actor or not actor.valid return end	-- wtf
	if (actor.flags2 & MF2_DEBRIS) then return end	-- already exploded

	-- VISUALS
	local boom = P_SpawnMobj(actor.x, actor.y, actor.z, MT_BP_MB_BOOMEXPLODE)
	boom.flags = MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT	-- just in case
	boom.scale = actor.scale*5
	
	local smoldering = P_SpawnMobj(actor.x, actor.y, actor.z, MT_SMOLDERING)
	K_MatchGenericExtraFlags(smoldering, actor)
	smoldering.tics = TICRATE
	
	local colour = (actor.target and actor.target.valid) and actor.target.color or SKINCOLOR_KETCHUP
	local r = actor.radius / FRACUNIT

	local amount = 8
	for i = 1, amount
		local dust = P_SpawnMobj(actor.x, actor.y, actor.z, MT_SMOKE)
		dust.state = S_OPAQUESMOKE1
		dust.scale = actor.scale*2
		dust.destscale = actor.scale*3
		dust.scalespeed = actor.scale/18
		P_InstaThrust(dust, (360/amount*i)*ANG1, 20*actor.scale)
	end
	
	for i = 1, 5
		local truc = P_SpawnMobj(actor.x + P_RandomRange(-r, r)*actor.scale, actor.y + P_RandomRange(-r, r)*actor.scale, actor.z + P_RandomRange(0, actor.height/FRACUNIT)*actor.scale, MT_BOOMPARTICLE)
		K_MatchGenericExtraFlags(truc, actor)
		truc.scale = actor.scale*2
		truc.destscale = actor.scale*3
		truc.scalespeed = actor.scale/18
		truc.tics = TICRATE*5/4

		truc.momx = P_RandomRange(-10, 10)*truc.scale
		truc.momy = P_RandomRange(-10, 10)*truc.scale
		truc.momz = P_RandomRange(-20, 20)*truc.scale
		truc.color = colour

		if (truc.eflags & MFE_UNDERWATER)
			truc.momz = ($*117) / 200	-- wtf?
		end
	end
	
	-- DAMAGE
	local explodedist = FixedMul((3*actor.info.painchance)/2, mapobjectscale)
	-- affect shootables with blockmap (makes it so chain reactions are possible)
	actor.flags2 = $|MF2_DEBRIS	-- make sure it doesnt explode twice
	actor.health = 0
	searchBlockmap("objects", mineblast.BlowMines, actor, actor.x - explodedist, actor.x + explodedist, actor.y - explodedist, actor.y + explodedist)
	-- actual explosion that damages
	for d = 0, 15
		K_SpawnKartExplosion(actor.x, actor.y, actor.z, explodedist + 32*mapobjectscale, 32, var1, d*(ANGLE_45/4), true, false, actor.target)
	end
	-- sound
	P_SpawnMobj(actor.x, actor.y, actor.z, MT_MINEEXPLOSIONSOUND)
	P_RemoveMobj(actor)
end)